package com.persagy.apm.diagnose.feign.client;

import com.alibaba.fastjson.JSONObject;
import com.persagy.apm.diagnose.feign.AlarmResult;
import com.persagy.apm.diagnose.service.dto.AlarmRuleDTO;
import com.persagy.apm.diagnose.service.dto.CalculateMethodDTO;
import com.persagy.apm.diagnose.service.dto.MonitorIndicatorConfigByEquipDTO;
import com.persagy.apm.diagnose.service.dto.MonitorIndicatorConfigDTO;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;


//@FeignClient(name = "energy-alarm-service",url = "http://192.168.16.247:9977")
@FeignClient(name = "energy-alarm-service")
public interface AlarmServiceClient {

    @PostMapping("/projectAlarmRuleObjRels/query")
    AlarmResult<JSONObject> query(@RequestBody MonitorIndicatorConfigDTO queryMonitorIndicatorConfigDTO) throws Exception;


    @PostMapping("/calculateMethods/query")
    AlarmResult<JSONObject> queryCalculateMethods(@RequestBody CalculateMethodDTO calculateMethodDTO) throws Exception;



    @PostMapping("/projectMonitorIndicatorConfigs/query_by_equip")
    AlarmResult<JSONObject> query_by_equip(@RequestBody MonitorIndicatorConfigByEquipDTO monitorIndicatorConfigByEquipDTO) throws Exception;


    @PostMapping("projectAlarmRules/query_with_indicators_objs")
    AlarmResult<JSONObject> queryProjectAlarmRules(@RequestBody AlarmRuleDTO alarmRuleDTO) throws Exception;
}
