package com.persagy.apm.diagnose.service;

import com.alibaba.fastjson.JSONObject;
import com.persagy.apm.energyalarmstarter.alarmdata.feign.AlarmUrlParam;
import com.persagy.apm.energyalarmstarter.alarmengine.service.NettyAlarmService;
import lombok.SneakyThrows;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.Arrays;
import java.util.List;

@Service
public class NettyAlarmServiceImpl extends NettyAlarmService {


    @Autowired
    private CenterDataService centerDataService;

    @Override
    public String getMeterId(String infoCode, String classCode) throws Exception {
        String separator = "_";
        if (!infoCode.contains(separator)) {
            throw new Exception("infoCode格式不正确，应包含'" + separator +
                    "'，classCode=" + classCode + "; infoCode=" + infoCode);
        }
        String[] tmp = infoCode.split(separator);
        return tmp[0];
    }

    @Override
    public String getFuncId(String infoCode, String classCode) throws Exception {
        String separator = "_";
        if (!infoCode.contains(separator)) {
            throw new Exception("infoCode格式不正确，应包含'" + separator +
                    "'，classCode=" + classCode + "; infoCode=" + infoCode);
        }
        int indexOf = infoCode.indexOf(separator);
        return infoCode.substring(indexOf + 1);
    }

    @Override
    public String getAlarmName(String projectId, String objId, String category) {
        return null;
    }

    @SneakyThrows
    @Override
    public JSONObject getAlarmSupplement(AlarmUrlParam alarmUrlParam, JSONObject alarmRecord) {
//        "supplement": {
//            "alarm_obj_name": "yy1中文名"
//        }
        String objId = alarmRecord.getString("objId");
        List<JSONObject> objectList = centerDataService.queryObjListByObjId(alarmRecord.getString("projectId"), Arrays.asList(objId));
        JSONObject supplement = new JSONObject();
        if (!CollectionUtils.isEmpty(objectList)) {
            supplement.put("alarm_obj_name", objectList.get(0).get("localName"));
        }
        return supplement;
    }

    @Override
    public String getAlarmRemark(AlarmUrlParam data, String objId, String itemCode) {
        return null;
    }

}
