package com.persagy.apm.diagnose.utils;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;



public class CalculateUtil {

	public static Pattern pattern = Pattern.compile("\\$\\{(.*?)}");

	public static final String SUM = "sum";
	public static final String MIN = "min";
	public static final String OBJTYPE = "obj";
	public static final String InfoCode = "InfoCode";


	public static final String CurrentTime = "CurrentTime";
	public static final String Last1hTime = "Last1hTime";
	public static final String Last15MinTime = "Last15MinTime";
	public static final String Last30MinTime = "Last30MinTime";
	public static final String Last45MinTime = "Last45MinTime";
	
	
	public static final String After1hTime = "After1hTime";
	public static final String After15MinTime = "After15MinTime";
	public static final String After30MinTime = "After30MinTime";
	public static final String After45MinTime = "After45MinTime";
	public static final String invalidTime = "-1";

	/***
	 * 
	 * Description: 获取公式中所有所有变量${}
	 * 
	 * @return List<String>
	 * @author shaohongbo
	 * @since 2021年8月2日: 上午9:59:34 Update By shaohongbo 2021年8月2日: 上午9:59:34
	 */
	public static List<String> getVariablesFromFormula(String computeFormula) {
		List<String> resultList = new ArrayList<>();
		// 匹配】
		Matcher matcher = pattern.matcher(computeFormula);
		// 处理匹配到的值
		while (matcher.find()) {
			resultList.add(matcher.group());
		}
		return resultList;
	}

	public static Date getStartTime(String time, Date timeFrom) {
		if (time.equals(CurrentTime)) {
			// 当前时间
			return timeFrom;
		}
		if (time.equals(Last1hTime)) {
			// 上一小时

			return DateUtils.addHours(timeFrom, -1);
		}
		if (time.equals(Last15MinTime)) {
			// 上15分钟
			return DateUtils.addMinutes(timeFrom, -15);
		}
		if (time.equals(Last30MinTime)) {
			// 上30分钟
			return DateUtils.addMinutes(timeFrom, -30);
		}
		if (time.equals(Last45MinTime)) {
			// 上45分钟
			return DateUtils.addMinutes(timeFrom, -45);
		}

		if (time.equals(After1hTime)) {
			// 上一小时
			return DateUtils.addHours(timeFrom, 1);
		}
		if (time.equals(After15MinTime)) {
			// 当前时间
			return DateUtils.addMinutes(timeFrom, 15);
		}
		if (time.equals(After30MinTime)) {
			// 当前时间
			return DateUtils.addMinutes(timeFrom, 30);
		}	
		if (time.equals(After45MinTime)) {
			// 当前时间
			return DateUtils.addMinutes(timeFrom, 45);
		}
		return null;
	}

}
