package com.persagy.apm.diagnose.utils;

import com.persagy.framework.ems.data.pojo.hbase.MonitorIndicatorRecord;
import org.springframework.util.CollectionUtils;

import java.util.List;


/**
 * @author leifeng
 * @version 1.0.0
 * @ClassName CollectDataUtil
 * @Description 报警服务发送数据工具类
 * @createTime 2021/9/25 18:41
 */
public class CollectDataUtil {

    public static String buildSendParam(List<MonitorIndicatorRecord> recordList) throws Exception {

        if (CollectionUtils.isEmpty(recordList)) {
            return null;
        }
        StringBuilder stringBuilder = new StringBuilder();
        MonitorIndicatorRecord record1 = recordList.get(0);
        String date = DateUtils.date2Str(record1.getDataTime(), "yyyyMMddHHmmss");
        stringBuilder.append(date).append(";");
        stringBuilder.append(record1.getObjId()).append(";");

        for (int i = 0; i < recordList.size(); i++) {
            stringBuilder.append(recordList.get(i).getMonitorIndicatorId());
            if (i == (recordList.size() - 1)) {
                stringBuilder.append(";");
            } else {
                stringBuilder.append(",");
            }
        }
        for (int i = 0; i < recordList.size(); i++) {
            stringBuilder.append(recordList.get(i).getDataValue());
            if (i == (recordList.size() - 1)) {
                stringBuilder.append(";");
            } else {
                stringBuilder.append(",");
            }
        }
        return stringBuilder.toString();

    }


}
